using System;

namespace Takmicenja
{
    class Program
    {
        static void Main(string[] args)
        {
            int n = int.Parse(Console.ReadLine());
            string[] s1 = Console.ReadLine().Split();
            int o = int.Parse(s1[0]), a = int.Parse(s1[1]), b = int.Parse(s1[2]), ab = int.Parse(s1[3]);
            int[,] p = new int[n, 4];
            int t = 0;
            int[] y = new int[n];
            string[] grupe = new string[n];
            for (int i = 0; i < n; i++)
            {
                string[] s2 = Console.ReadLine().Split();
                grupe[i] = s2[0];
                y[i] = int.Parse(s2[1]);
            }
            for (int i = 0; i < n; i++)
            {
                if (grupe[i] == "O")
                {
                    if (y[i] <= o)
                    {
                        p[i, 0] = y[i];
                    }
                    else
                    {
                        t++;
                        Console.WriteLine("nemoguce");
                        break;
                    }
                }
                if (grupe[i] == "A")
                {
                    if (y[i] <= a)
                    {
                        p[i, 1] = y[i];
                    }
                    else
                    {
                        if (y[i] > 0)
                        {
                            p[i, 1] = a;
                            p[i, 0] = y[i] - a;
                        }
                    }
                }
                if (grupe[i] == "B")
                {
                    if (y[i] <= b)
                    {
                        p[i, 2] = y[i];
                    }
                    else
                    {
                        if (y[i] - b > 0)
                        {
                            p[i, 2] = b;
                            p[i, 0] = y[i] - b;
                        }
                    }
                }
                if (grupe[i] == "AB")
                {
                    if (y[i] <= ab)
                    {
                        p[i, 3] = y[i];
                    }
                    else
                    {
                        if (y[i] > 0)
                        {
                            p[i, 3] = ab;
                            if (y[i] - ab <= b)
                            {
                                p[i, 2] = y[i] - ab;
                            }
                            else
                            {
                                if (y[i] > 0)
                                {
                                    p[i, 2] = b;
                                    if (y[i] - b <= a)
                                    {
                                        p[i, 1] = y[i] - b;
                                    }
                                    else
                                    {
                                        if (y[i] - a > 0)
                                        {
                                            p[i, 1] = a;
                                            p[i, 0] = y[i] - a;
                                        }
                                    }
                                }

                            }
                        }
                    }
                }
                for (int j = 0; j < n; j++)
                {
                    if (p[j, i] < 0)
                    {
                        t++;
                        Console.WriteLine("nemoguce");
                        break;
                    }
                }
                o = o - p[i, 0];
                a = a - p[i, 1];
                b = b - p[i, 2];
                ab = ab - p[i, 3];
            }
            if (t == 0)
            {
                Console.WriteLine("moguce");
                for (int i = 0; i < n; i++)
                {
                    for (int j = 0; j < 4; j++)
                    {
                        Console.Write(p[i, j] + " ");
                    }
                    Console.WriteLine();
                }
            }
        
        }
    }
}